﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace MW_FileDownLoadEx
{
    /// <summary>
    /// 
    /// </summary>
    public class ClientSocket : Socket
    {
        private const int BITCOUNTLENGTH = 4;
        private IPEndPoint ipep;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="szServerName"></param>
        /// <param name="nPort"></param>
        public ClientSocket(String szServerName,int nPort) 
            : base(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
        {
            ipep = new IPEndPoint(IPAddress.Parse(szServerName), nPort);
            Connect(ipep);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nData"></param>
        /// <returns></returns>
        new public bool Send(byte[] nData)
        {
            if (!Connected)
            {
                return false;
            }
            byte[] nbitCount = BitConverter.GetBytes(nData.Length);
            Send(nbitCount, BITCOUNTLENGTH, SocketFlags.None);
            Send(nData, nData.Length, SocketFlags.None);
            return true;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nData"></param>
        /// <returns></returns>
        public bool Receive(out byte[] nData)
        {
            if (!Connected)
            {
                nData = null;
                return false;
            }
            byte[] nBitCount = new byte[BITCOUNTLENGTH];
            Receive(nBitCount, BITCOUNTLENGTH, SocketFlags.None);
            int nDataLength = BitConverter.ToInt32(nBitCount,0);
            nData = new byte[nDataLength];
            Receive(nData, nDataLength, SocketFlags.None);
            return true;
        }
        public bool Receive(out byte[] nData,int i)
        {
            if (!Connected)
            {
                nData = null;
                return false;
            }
            byte[] nBitCount = new byte[BITCOUNTLENGTH];
            Receive(nBitCount, BITCOUNTLENGTH, SocketFlags.None);
            int nDataLength = BitConverter.ToInt32(nBitCount, 0);
            nData = new byte[nDataLength];
            Receive(nData, nDataLength, SocketFlags.None);
            return true;
        }
    }
}
