﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;
using System.Diagnostics;

namespace MW_FileDownLoadEx
{
    public partial class MW_ClientForm : UserControl,IDisposable
    {
        private delegate void SetTextCallBack(String szText);

        private ClientSocket m_cClient;
        private Thread m_cClientThread;
        /// <summary>
        /// 
        /// </summary>
        private enum ClientType
        {
            Start,
            End
        }
        /// <summary>
        /// 
        /// </summary>
        public MW_ClientForm()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 
        /// </summary>
        new public void Dispose()
        {
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MW_ClientForm_Load(object sender, EventArgs e)
        {
            Properties.Settings.Default.wndClientForm = (int)Handle;
            m_cClient = null;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="m"></param>
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WINAPI.ClientButtonEnble)
            {
                
                cClientStartButton.Enabled = true;
            }
            base.WndProc(ref m);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cClientStartButton_Click(object sender, EventArgs e)
        {
            cClientStartButton.Enabled = false;
            m_cClientThread = new Thread(new ThreadStart(Client));
            m_cClientThread.Start();
            
        }
        /// <summary>
        /// 
        /// </summary>
        private void Client()
        {
            m_cClient = new ClientSocket("127.0.0.1", 9500);
            MainSetText(Properties.MSG.ClientConnect);

            MainSetText(Properties.MSG.ServerStartProtocal);
            if (Protocal(ClientType.Start))
            {
                MainSetText(Properties.MSG.ServerOkProtocal);

                DataReceive();

                MainSetText(Properties.MSG.ServerEndProtocal);
                Protocal(ClientType.End);
                MainSetText(Properties.MSG.ServerOkProtocal);
            }
            m_cClient.Disconnect(false);
            m_cClient.Close();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="type"></param>
        /// <returns></returns>
        private bool Protocal(ClientType type)
        {
            bool bCheck = false;
            byte[] nRet = null;
            switch (type)
            {
                case ClientType.Start:
                    m_cClient.Receive(out nRet);
                    if (Encoding.Default.GetString(nRet).Equals(Properties.Resources.SockStart))
                    {
                        m_cClient.Send(Encoding.Default.GetBytes(Properties.Resources.SockOK));
                        bCheck = true;
                    }
                    else {
                        m_cClient.Send(Encoding.Default.GetBytes(Properties.Resources.SockFaild));
                    }
                    break;
                case ClientType.End:
                    m_cClient.Receive(out nRet);
                    if (Encoding.Default.GetString(nRet).Equals(Properties.Resources.SockEnd))
                    {
                        m_cClient.Send(Encoding.Default.GetBytes(Properties.Resources.SockOK));
                        bCheck = true;
                    }
                     else
                     {
                         m_cClient.Send(Encoding.Default.GetBytes(Properties.Resources.SockFaild));
                     }
                     break;
            }
            return bCheck;
        }
        /// <summary>
        /// 
        /// </summary>
        private void DataReceive()
        {
            byte[] nBuffer;
            int nFileCount = 0;
            String szFileCount = "";
            String szDataBuffer = "";

            m_cClient.Receive(out nBuffer);
            szDataBuffer = Encoding.Default.GetString(nBuffer);
            szFileCount = DataDecoding(Properties.Resources.SockFileCount, szDataBuffer);
            MainSetText(szDataBuffer);
            nFileCount = Convert.ToInt32(szFileCount);
            WINAPI.PostMessage(Properties.Settings.Default.wndMainForm, WINAPI.MainProgress, nFileCount, 0);
            for (int i = 0; i < nFileCount; i++)
            {
                FileReceive();

                m_cClient.Send(Encoding.Default.GetBytes(Properties.Resources.SockFileDownOk));
                m_cClient.Receive(out nBuffer);
                if (!Encoding.Default.GetString(nBuffer).Equals(Properties.Resources.SockOK))
                {
                    break;
                }

                WINAPI.PostMessage(Properties.Settings.Default.wndMainForm, WINAPI.MainProgress, nFileCount, i);
            }
            WINAPI.PostMessage(Properties.Settings.Default.wndMainForm, WINAPI.MainProgress, nFileCount, nFileCount);
            Process.Start(".\\DownLoad");
        }
        /// <summary>
        /// 
        /// </summary>
        private void FileReceive()
        {
            StringBuilder szBuffer = new StringBuilder();
            long nTime = DateTime.Now.Ticks;
            byte[] nBuffer;
            String szDataBuffer;
            String szFileName;
            int nFileSize;
            m_cClient.Receive(out nBuffer);
            szDataBuffer = Encoding.Default.GetString(nBuffer);
            MainSetText(szDataBuffer);
            szFileName = DataDecoding(Properties.Resources.SockFileName, szDataBuffer);                 //Filename
            
            m_cClient.Receive(out nBuffer);
            szDataBuffer = Encoding.Default.GetString(nBuffer);
            nFileSize = Convert.ToInt32(DataDecoding(Properties.Resources.SockFileSize, szDataBuffer));     //FileSize

            if (!Directory.Exists("DownLoad"))
            {
                Directory.CreateDirectory("DownLoad");
            }
            FileStream cStream = new FileStream("DownLoad\\" + szFileName,FileMode.Create,FileAccess.Write);
            
            for (int nClientIndex = 0; nClientIndex < nFileSize; )
            {
                nBuffer = null;
                nBuffer = new byte[4096];
                m_cClient.Receive(nBuffer, 4096, System.Net.Sockets.SocketFlags.None);
                cStream.Write(nBuffer, 0, 4096);

                szBuffer.Append(Encoding.Default.GetString(nBuffer));
                szBuffer.Remove(0, szBuffer.Length);
                nBuffer.Initialize();

                WINAPI.PostMessage(Properties.Settings.Default.wndMainForm, WINAPI.SubProgress, nFileSize, nClientIndex);

                nClientIndex += 4096;
            }
            nBuffer = new byte[nFileSize % 4096];
            m_cClient.Receive(nBuffer, nFileSize % 4096, System.Net.Sockets.SocketFlags.None);
            cStream.Write(nBuffer, 0, nBuffer.Length);

            WINAPI.PostMessage(Properties.Settings.Default.wndMainForm, WINAPI.SubProgress, nFileSize, nFileSize);

            cStream.Close();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="szNode"></param>
        /// <param name="szData"></param>
        /// <returns></returns>
        private String DataDecoding(String szNode, String szData)
        {
            int nSPos = szData.IndexOf(String.Format("<{0}>", szNode)) + szNode.Length + 2;
            int nEPos = szData.IndexOf(String.Format("</{0}>", szNode));
            return szData.Substring(nSPos, nEPos - nSPos);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="szText"></param>
        private void MainSetText(String szText)
        {
            if (cMainTextBox.InvokeRequired)
            {
                SetTextCallBack setCallBack = new SetTextCallBack(MainSetText);
                this.Invoke(setCallBack, szText);
            }
            else
            {
                this.cMainTextBox.AppendText(szText);
                this.cMainTextBox.AppendText("\r\n");
                this.cMainTextBox.ScrollToCaret();
                this.cMainTextBox.Focus();
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="szText"></param>
        private void SubSetText(String szText)
        {
            if (cMainTextBox.InvokeRequired)
            {
                SetTextCallBack setCallBack = new SetTextCallBack(SubSetText);
                this.Invoke(setCallBack, szText);
            }
            else
            {
                this.cSubTextBox.AppendText(szText);
                this.cSubTextBox.ScrollToCaret();
                this.cSubTextBox.Focus();
            }
        }
    }
}
