﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;
using System.Diagnostics;

namespace MW_FileDownLoadEx
{
    public partial class MW_ServerForm : UserControl,IDisposable
    {
        private delegate void SetTextCallBack(String szText);

        private ServerSocket m_cServer;
        private Thread m_cServerThread;
        private DirectoryInfo m_cDirectory;
        /// <summary>
        /// 
        /// </summary>
        private enum ServerType
        {
            Start,
            End
        }
        /// <summary>
        /// 
        /// </summary>
        public MW_ServerForm()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MW_ServerForm_Load(object sender, EventArgs e)
        {
            m_cServer = null;
            m_cServerThread = null;
            Properties.Settings.Default.wndServerForm = (int)Handle;
        }
        /// <summary>
        /// 
        /// </summary>
        new public void Dispose()
        {
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cFileOpenButton_Click(object sender, EventArgs e)
        {
            if (cFolderBrowser.ShowDialog() == DialogResult.OK)
            {
                cPathTextBox.Text = cFolderBrowser.SelectedPath.ToString();
                cFileOpenButton.Enabled = false;
                cServerStartButton.Enabled = true;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cServerStartButton_Click(object sender, EventArgs e)
        {
            cServerStartButton.Enabled = false;
            m_cServerThread = new Thread(new ThreadStart(Server));
            m_cServerThread.Start();
            WINAPI.PostMessage(Properties.Settings.Default.wndClientForm, WINAPI.ClientButtonEnble, null, null);
        }
        /// <summary>
        /// 
        /// </summary>
        private void Server()
        {
            m_cServer = new ServerSocket(9500);
            MainSetText(Properties.MSG.ServerStart);
            m_cServer.Accept();
            MainSetText(Properties.MSG.ServerAccept);
            m_cDirectory = new DirectoryInfo(cPathTextBox.Text);

            MainSetText(Properties.MSG.ServerStartProtocal);
            if (Protocal(ServerType.Start))
            {
                MainSetText(Properties.MSG.ServerOkProtocal);

                DataSend();

                MainSetText(Properties.MSG.ServerEndProtocal);
                Protocal(ServerType.End);
                MainSetText(Properties.MSG.ServerOkProtocal);
            }
            m_cServer.Close();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="type"></param>
        /// <returns></returns>
        private bool Protocal(ServerType type)
        {
            byte[] nRet = null;
            switch (type)
            {
                case ServerType.Start:
                    m_cServer.Send(Encoding.Default.GetBytes(Properties.Resources.SockStart));
                    m_cServer.Receive(out nRet);
                    break;
                case ServerType.End:
                    m_cServer.Send(Encoding.Default.GetBytes(Properties.Resources.SockEnd));
                    m_cServer.Receive(out nRet);
                    break;
            }
            if (Encoding.Default.GetString(nRet).Equals(Properties.Resources.SockOK))
            {
                return true;
            }
            return false;
        }
        /// <summary>
        /// 
        /// </summary>
        private void DataSend() 
        {
            int nCount = 0;
            FileInfo[] cFiles;
            byte[] nRet;
            String szDataBuffer;

            cFiles = m_cDirectory.GetFiles();
            nCount = cFiles.Length;
            
            szDataBuffer = DataDecoding(Properties.Resources.SockFileCount,nCount);
            m_cServer.Send(Encoding.Default.GetBytes(szDataBuffer));
            MainSetText(szDataBuffer);

            for (int i = 0; i < nCount; i++)
            {
                FildSend(cFiles[i]);
                                
                m_cServer.Receive(out nRet);
                if (Encoding.Default.GetString(nRet).Equals(Properties.Resources.SockFileDownOk))
                {
                    m_cServer.Send(Encoding.Default.GetBytes(Properties.Resources.SockOK));
                }
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="cFile"></param>
        private void FildSend(FileInfo cFile)
        {
            StringBuilder szBuffer = new StringBuilder();
            long nTime = DateTime.Now.Ticks;
            int nDataLenth;
            byte[] nFileBuffer;
 
            String szDataBuffer;
            szDataBuffer = DataDecoding(Properties.Resources.SockFileName, cFile.Name);
            m_cServer.Send(Encoding.Default.GetBytes(szDataBuffer));
            MainSetText(szDataBuffer);
            
            FileStream cStream = new FileStream(cFile.FullName, FileMode.Open, FileAccess.Read);
            nDataLenth = (int)cStream.Length;

            szDataBuffer = DataDecoding(Properties.Resources.SockFileSize, nDataLenth);
            m_cServer.Send(Encoding.Default.GetBytes(szDataBuffer));                                //size
            cStream.Seek(0, SeekOrigin.Begin);
            for (int nSendFileIndex = 0; nSendFileIndex < nDataLenth;)
            {
                nFileBuffer = new byte[4096];
                cStream.Read(nFileBuffer, 0, 4096);   
                m_cServer.Send(nFileBuffer, 4096);

                nSendFileIndex += 4096;
            }
            nFileBuffer = new byte[nDataLenth % 4096];
            cStream.Read(nFileBuffer, 0, nDataLenth % 4096);
            m_cServer.Send(nFileBuffer, nDataLenth % 4096);

            cStream.Close();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="szNode"></param>
        /// <param name="oData"></param>
        /// <returns></returns>
        private String DataDecoding(String szNode, object oData)
        {
            return String.Format("<{0}>{1}</{0}>", szNode, oData);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="szText"></param>
        private void MainSetText(String szText)
        {
            if (cMainTextBox.InvokeRequired)
            {
                SetTextCallBack setCallBack = new SetTextCallBack(MainSetText);
                this.Invoke(setCallBack, szText);
            }
            else
            {
                this.cMainTextBox.AppendText(szText);
                this.cMainTextBox.AppendText("\r\n");
                this.cMainTextBox.ScrollToCaret();
                this.cMainTextBox.Focus();
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="szText"></param>
        private void SubSetText(String szText)
        {
            if (cMainTextBox.InvokeRequired)
            {
                SetTextCallBack setCallBack = new SetTextCallBack(SubSetText);
                this.Invoke(setCallBack, szText);
            }
            else
            {
                this.cSubTextBox.AppendText(szText);
                this.cSubTextBox.ScrollToCaret();
                this.cSubTextBox.Focus();
            }
        }
    }
}
