﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace MW_FileDownLoadEx
{
    public class ServerSocket : Socket
    {
        private const int BITCOUNTLENGTH = 4;
        private const int LISTENQUEE = 20;
        private IPEndPoint ipep;
        private Socket m_SubServer;
        
        private int m_nPort;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nPort"></param>
        public ServerSocket(int nPort)
            : base(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
        {
            m_nPort = nPort;

            ipep = new IPEndPoint(IPAddress.Any, nPort);
            Bind(ipep);
            Listen(LISTENQUEE);
        }
        /// <summary>
        /// 
        /// </summary>
        new public void Accept()
        {
            m_SubServer = base.Accept();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nData"></param>
        /// <returns></returns>
        new public bool Send(byte[] nData)
        {
            if (!m_SubServer.Connected)
            {
                return false;
            }
            byte[] nbitCount = BitConverter.GetBytes(nData.Length);
            m_SubServer.Send(nbitCount, BITCOUNTLENGTH, SocketFlags.None);
            m_SubServer.Send(nData, nData.Length, SocketFlags.None);
            return true;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nData"></param>
        /// <param name="nSize"></param>
        /// <returns></returns>
        public bool Send(byte[] nData, int nSize)
        {
            if (!m_SubServer.Connected)
            {
                return false;
            }
            m_SubServer.Send(nData, nSize, SocketFlags.None);
            return true;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nData"></param>
        /// <returns></returns>
        public bool Receive(out byte[] nData)
        {
            if (!m_SubServer.Connected)
            {
                nData = null;
                return false;
            }
            byte[] nBitCount = new byte[BITCOUNTLENGTH];
            m_SubServer.Receive(nBitCount, BITCOUNTLENGTH, SocketFlags.None);
            int nDataLength = BitConverter.ToInt32(nBitCount, 0);
            nData = new byte[nDataLength];
            m_SubServer.Receive(nData, nDataLength, SocketFlags.None);
            return true;
        }
    }
}
